#include "pw/io/image_io.hpp"

#include "stb_image.h"
#include "stb_image_write.h"


namespace pw {


struct image_io::impl
{

    image read_impl(const std::string& uri,uint32_t flags)
    {
        int x,y,n;

        unsigned char *data = stbi_load(uri.c_str(), &x, &y, &n, 4);

        if (data) {

            image r;
            r.create(sizei(x,y),image::pixel_layout::RGBA8,data);
            return r;
        }

        return image();
    }

};


image_io &image_io::get()
{
    static image_io instance;
    return instance;
}

image image_io::read(const std::string &uri, uint32_t flags)
{
    return _impl->read_impl(uri,flags);
}

}
